<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2005 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * $Source: /home/www/dps3311/home/cvsroot/pragmamx/pragmamx_01/modules/Recommend_Us/index.php,v $
 * $Revision: 1.8 $
 * $Author: tora60 $
 * $Date: 2007/03/19 17:09:25 $
 * 
 * this file based on:
 * TPK Recommend us
 * Copyright (c) 2002 by Jochem Schausten (webmaster@phpnuke-module.de), http://www.phpnuke-module.de
 * Copyright (C) 2003 by Future (info@powerfiles.de), http://www.PowerFiles.de
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
$pagetitle = _RECOMMEND;
// / rechte Bloecke anzeigen?
// / 0 = nein, 1 = ja
$index = 0;

require("includes/captcha/settings.php");
$recommendon = (($recommendon) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) ? 1 : 0;

/**
 * das Formular
 */
function RecommendSite($event = array())
{
    if (MX_IS_USER && empty($event['yname']) && empty($event['ymail'])) {
        $uinfo = mxGetUserData();
        $event['yname'] = $uinfo['uname'];
        $event['ymail'] = $uinfo['email'];
    } 
    include_once("header.php");
    title(_RECOMMEND);
    if (isset($event['recerror'])) {
        openTableAl();
        echo '<div style="text-align: left;"><h2>' . _REC_ERRORTITLE . '</h2><ul><li>' . implode('</li><li>', $event['recerror']) . '</li></ul></div>';
        closeTableAl();
        echo '<br>';
    } 
    OpenTable();
    echo "<form action=\"modules.php?name=" . $GLOBALS['module_name'] . "\" method=\"post\" name=\"sendform\">"
     . "<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS['module_name'] . "\">"
     . "<input type=\"hidden\" name=\"op\" value=\"SendSite\">"
     . "<input type=\"hidden\" name=\"site\" value=\"" . urlencode(strip_tags(getenv("HTTP_REFERER"))) . "\">"
     . "<table>"
     . "<tr><td>" . _FFRIENDNAME . " </td><td> <input type=\"text\" name=\"fname\" value=\"" . (isset($event['fname']) ? mxEntityQuotes($event['fname']): '') . "\" size=\"35\"></td></tr>\n"
     . "<tr><td>" . _FFRIENDEMAIL . " </td><td> <input type=\"text\" name=\"fmail\" value=\"" . (isset($event['fmail']) ? mxEntityQuotes($event['fmail']): '') . "\" size=\"35\"></td></tr>\n"
     . "<tr valign=\"top\"><td>" . _FREMARKS . " </td><td><textarea name=\"ftext\" cols=\"35\" rows=\"5\">" . (isset($event['ftext']) ? mxEntityQuotes(strip_tags($event['ftext'])): '') . "</textarea></td></tr>\n"
     . "<tr><td>" . _FYOURNAME . " </td><td> <input type=\"text\" name=\"yname\" value=\"" . (!empty($event['yname']) ? mxEntityQuotes($event['yname']): '') . "\" size=\"35\"></td></tr>\n"
     . "<tr><td>" . _FYOUREMAIL . " </td><td> <input type=\"text\" name=\"ymail\" value=\"" . (!empty($event['ymail']) ? mxEntityQuotes($event['ymail']): '') . "\" size=\"35\"></td></tr>\n"
     . "";
    if ($GLOBALS['recommendon']) {
        include('includes/captcha/captcha_java.php');
        echo "<tr><td>&nbsp;</td><td><div><img id=\"captchaimage\" src=\"includes/captcha/captchaimg.php?" . md5(crypt(uniqid(rand()))) . "\" alt=\"" . _CAPTCHAINSERT . "\"></div></td></tr>\n"
         . "<tr><td>" . _CAPTCHAINSERT . " </td><td><input type=\"text\" name=\"captcha\" value=\"\" size=\"20\" maxlength=\"20\"></td></tr>\n";
    } 
    echo "<tr><td colspan=\"2\" align=\"center\"><br><input type=\"submit\" value=\"" . _SEND . "\">";
    if ($GLOBALS['recommendon']) {
        echo "&nbsp;&nbsp;<input type=\"button\" value=\"" . _CAPTCHARELOAD . "\" onclick=\"do_reload(); document.sendform.captcha.focus(); return false;\">";
    } 
    echo "</td></tr></table>"
     . "</form>\n";
    CloseTable();
    include_once('footer.php');
} 

/**
 * Die Verarbeitung und Fehlerpr&uuml;fung
 */
function SendSite()
{
    global $sitename, $slogan, $prefix, $adminmail, $module_name;

    $event = mxStripSlashes($_POST);

    if (empty($event['yname'])) { // || !eregi('^[0-9a-z\- _.]+$', $event['yname'])
        $event['recerror'][] = _REC_ERRORNAME;
    } 
    if (empty($event['ymail']) || !preg_match('~^[0-9A-Za-z=_+\-/][0-9A-Za-z=_\'+\-/\.]+@[\w\-]+(\.[\w\-]+)*(\.[\w]{2,6})$~', $event['ymail'])) {
        $event['recerror'][] = _REC_ERRORSENDER;
    } 
    if (empty($event['fmail']) || !preg_match('~^[0-9A-Za-z=_+\-/][0-9A-Za-z=_\'+\-/\.]+@[\w\-]+(\.[\w\-]+)*(\.[\w]{2,6})$~', $event['fmail'])) {
        $event['recerror'][] = _REC_ERRORRECEIVER;
    } 
    // captcha pruefen
    if (isset($GLOBALS['recommendon']) && $GLOBALS['recommendon']) {
        if (empty($_POST['captcha'])) {
            $event['recerror'][] = _CAPTCHAWRONG;
        } else {
            require_once("includes/captcha/__captcha/PhraseFactory.php");
            $storedCaptcha = PhraseFactory::get('', $GLOBALS['passphraselenght'], $_POST['captcha'], $GLOBALS['storagetype']);
            if ($_POST['captcha'] !== $storedCaptcha) {
                $event['recerror'][] = _CAPTCHAWRONG;
            } 
        } 
    } 
    if (isset($event['recerror'])) {
        RecommendSite($event);
    } else {
        // error_reporting(E_ALL);
        // mxDebugFuncVars($event);
        if (MX_IS_USER) {
            $cookie = mxGetUserSession();
        } else {
            $cookie[0] = 0;
        } 
        $event['ftext'] = (empty($event['ftext'])) ? "" : "" . $event['ftext'] . "\n\n\n";
        $subject = _INTSITE . " $sitename";
        $message = _HELLO . " " . $event['fname'] . ":\n\n" . _YOURFRIEND . " " . $event['yname'] . " " . _OURSITE . " \"$sitename\" " . _INTSENT . "\n\n\n" . $event['ftext'] . _FSITENAME . " $sitename\n$slogan\n" . _FSITEURL . " " . MX_HOME_URL . "\n"; 
        // mxDebugFuncVars($subject, $message);
        if (mxMail($event['fmail'], $subject, $message, $event['ymail'], "text", "", $event['yname'])) {
            sql_query("INSERT INTO " . $prefix . "_recommend VALUES (NULL,'" . mxAddSlashesForSQL(strip_tags($fname)) . "','" . $event['fmail'] . "','" . mxAddSlashesForSQL(strip_tags($event['yname'])) . "','" . $event['ymail'] . "','" . $cookie[0] . "','" . mxAddSlashesForSQL(MX_REMOTE_ADDR) . "','" . time() . "','" . mxAddSlashesForSQL(strip_tags($site)) . "')");
        } 
        // das ist nur eine Dummy-Weiterleitung um das Aktualisieren der Seite zu verhindern
        mxRedirect('modules.php?name=' . $module_name . '&op=SiteSent&fname=' . urlencode($event['fname']) . '&yname=' . urlencode($event['yname']) . '&ymail=' . urlencode($event['ymail']), '', 0);
    } 
} 

/**
 * das ist nur eine Dummy-Weiterleitung um das Aktualisieren der Seite zu verhindern
 */
function SiteSent()
{
    global $module_name;
    $event = mxStripSlashes($_GET);
    mxRedirect('modules.php?name=' . $module_name . '&amp;ymail=' . urlencode($event['ymail']) . '&amp;yname=' . $event['yname'], _FREFERENCE . " " . mxStripSlashes(urldecode($event['fname'])) . "...<br><br>" . _THANKSREC, 5);
} 

/**
 * Auswahl der Optionen
 */
$op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : "";
switch ($op) {
    case "SendSite":
        SendSite();
        break;

    case "SiteSent":
        SiteSent();
        break;

    default:
        RecommendSite($_GET);
        break;
} 

?>